import * as i0 from '@angular/core';
import { Injectable, Component, NgModule, InjectionToken } from '@angular/core';
import { createAction, props, createReducer, on, createFeatureSelector, createSelector } from '@ngrx/store';
import * as fromRouter from '@ngrx/router-store';

class ShareStateService {
    constructor() { }
}
ShareStateService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
ShareStateService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class ShareStateComponent {
    constructor() { }
    ngOnInit() {
    }
}
ShareStateComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ShareStateComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.5", type: ShareStateComponent, selector: "lib-share-state", ngImport: i0, template: `
    <p>
      share-state works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-share-state',
                    template: `
    <p>
      share-state works!
    </p>
  `,
                    styles: []
                }]
        }], ctorParameters: function () { return []; } });

class ShareStateModule {
}
ShareStateModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ShareStateModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, declarations: [ShareStateComponent], exports: [ShareStateComponent] });
ShareStateModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ShareStateComponent
                    ],
                    imports: [],
                    exports: [
                        ShareStateComponent
                    ]
                }]
        }] });

const addUser = createAction('[User] Add User', props());
const removeUser = createAction('[User] Remove User', props());

var user_action = /*#__PURE__*/Object.freeze({
    __proto__: null,
    addUser: addUser,
    removeUser: removeUser
});

const userFeatureKey = 'user';
class UserStateModel {
}
const initialState = {
    users: [],
};
const reducer = createReducer(initialState, on(addUser, (state, { user }) => ({
    users: [...state.users, user],
})), on(removeUser, (state, { user }) => ({
    users: state.users.filter(u => !(u.email === user.email && u.name === user.name)),
})));
const selectUsers$1 = (state) => state.users;

/**
 * Our state is composed of a map of action reducer functions.
 * These reducer functions are called with each dispatched action
 * and the current or initial state and return a new immutable state.
 */
const ROOT_REDUCERS = new InjectionToken('Root reducers token', {
    factory: () => ({
        [userFeatureKey]: reducer,
        router: fromRouter.routerReducer,
    }),
});
// console.log all actions
function logger(reducer) {
    return (state, action) => {
        const result = reducer(state, action);
        console.groupCollapsed(action.type);
        console.log('prev state', state);
        console.log('action', action);
        console.log('next state', result);
        console.groupEnd();
        return result;
    };
}
const isProd = false; // environment.production cannot be shared with multiple apps there, a injection token is required?
/**
 * By default, @ngrx/store uses combineReducers with the reducer map to compose
 * the root meta-reducer. To add more meta-reducers, provide an array of meta-reducers
 * that will be composed to form the root meta-reducer.
 */
const metaReducers = !isProd ? [logger] : [];
/**
 * User Selectors
 */
const selectUserState = createFeatureSelector(userFeatureKey);
const selectUsers = createSelector(selectUserState, selectUsers$1);
/**
 * Router Selectors
 */
const selectRouter = createFeatureSelector('router');
const { selectRouteData } = fromRouter.getSelectors(selectRouter);

/*
 * Public API Surface of share-state
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ROOT_REDUCERS, ShareStateComponent, ShareStateModule, ShareStateService, user_action as UserActions, logger, metaReducers, selectRouteData, selectRouter, selectUserState, selectUsers };
//# sourceMappingURL=share-state.js.map
